<?php

require_once __DIR__ . '/ExtractionExtraction.class.inc';
require_once dirname($_SERVER['SCRIPT_FILENAME']) . '/class/vitis_lib/Connection.class.inc';

/**
 * \file Coordsys.class.inc
 * \class Coordsys
 *
 * \author WAB <support.wab@veremes.com>.
 *
 * 	\brief This file contains the Coordsys php class
 *
 * This class defines operation for one Coordsys
 * 
 */
class Coordsys extends ExtractionExtraction {

    public $oError;

    /**
     * construct
     * @param type $aPath url of the request
     * @param type $aValues parameters of the request
     * @param type $properties properties
     * @param type $bShortcut false to reinit variables
     * @param type $oConnection connection object
     */
    function __construct($aPath, $aValues, $properties, $bShortcut = false, $oConnection = false){
        parent::__construct($aPath, $aValues, $properties, $bShortcut, $oConnection);
    }

/**
     * @SWG\Get(path="/coordsyss/{id_coordsys}", 
     *   tags={"Coordsyss"},
     *   summary="Get Coordsys",
     *   description="Request to get Coordsys by id",
     *   operationId="GET",
     *   produces={"application/xml", "application/json"},
     *   @SWG\Parameter(
     *     name="token",
     *     in="query",
     *     description="user token",
     *     required=true,
     *     type="string"
     *   ),
     * @SWG\Parameter(
     *     name="id_coordsys",
     *     in="path",
     *     description="id_coordsys",
     *     required=true,
     *     type="integer",
     *   format="int32"
     *   ),
     * @SWG\Parameter(
     *     name="attributs",
     *     in="query",
     *     description="list of attributs",
     *     required=false,
     *     type="string"
     *   ),
     *   @SWG\Response(
     *         response=200,
     *         description="Coordsys Response",
     *         @SWG\Schema(ref="#/definitions/coordsyss")
     *     )
     *  )
     */

    /**
     * get informations about mode
     */
    function GET() {
        $this->aFields = $this->getFields($this->aProperties['schema_extraction'], "rt_coordsys", "coordsys_id");
    }

/**
     * delete a Point_situation
     */
    function DELETE() {
        $this->oConnection->oBd->delete($this->aProperties['schema_extraction'], 'rt_coordsys', 'coordsys_id', $this->aValues["my_vitis_id"], 'integer');
        if ($this->oConnection->oBd->enErreur()) {
            $this->oError = new Error(1, $this->oConnection->oBd->getBDMessage());
        } else {
            $this->aFields["coordsys_id"] = $this->aValues["my_vitis_id"];
        }
    }

}

?>