<?php

require_once __DIR__ . '/ExtractionExtraction.class.inc';
require_once __DIR__ . '/../../class/vitis_lib/Connection.class.inc';

/**
 * \file Extraction_depot.class.inc
 * \class Extraction_depot
 *
 * \author WAB <support.wab@veremes.com>.
 *
 * 	\brief This file contains the Extraction_depot php class
 *
 * This class defines operation for one Extraction_depot
 * 
 */
class Extraction_depot extends ExtractionExtraction {

    public $oError;

    /**
     * construct
     * @param type $aPath url of the request
     * @param type $aValues parameters of the request
     * @param type $properties properties
     * @param type $bShortcut false to reinit variables
     * @param type $oConnection connection object
     */
    function __construct($aPath, $aValues, $properties, $bShortcut = false, $oConnection = false){
        parent::__construct($aPath, $aValues, $properties, $bShortcut, $oConnection);
    }

	/**
     * @SWG\Get(path="/extraction_depots/{id_extraction_depot}", 
     *   tags={"Extraction_depots"},
     *   summary="Get Extraction_depot",
     *   description="Request to get Extraction_depot by id",
     *   operationId="GET",
     *   produces={"application/xml", "application/json"},
     *   @SWG\Parameter(
     *     name="token",
     *     in="query",
     *     description="user token",
     *     required=true,
     *     type="string"
     *   ),
     * @SWG\Parameter(
     *     name="id_extraction_depot",
     *     in="path",
     *     description="id_extraction_depot",
     *     required=true,
     *     type="integer",
     *   format="int32"
     *   ),
     * @SWG\Parameter(
     *     name="attributs",
     *     in="query",
     *     description="list of attributs",
     *     required=false,
     *     type="string"
     *   ),
     *   @SWG\Response(
     *         response=200,
     *         description="Extraction_depot Response",
     *         @SWG\Schema(ref="#/definitions/extraction_depots")
     *     )
     *  )
     */

    /**
     * get informations about mode
     */
    function GET() {
        $this->aFields = $this->getFields($this->aProperties['schema_extraction'], "", "");
    }



}

?>